import{s as Il,f as x,n as Pl,o as Dl}from"../chunks/scheduler.37c15a92.js";import{S as $l,i as jl,g as l,s as m,r as pe,m as r,H as h,A as Nl,h as p,f as a,c as i,j as o,u as me,x as g,n as c,B as u,k as v,y as t,a as e,v as ie,d as re,t as ce,w as oe}from"../chunks/index.7cb9c9b8.js";import{H as he}from"../chunks/Heading.d3928e2a.js";function Ol(ge){let L,pa,Xs,ma,j,ia,N,ue="The last thing we need to discuss before diving into Q-Learning is the two learning strategies.",ra,O,ve="Remember that an RL agent <strong>learns by interacting with its environment.</strong> The idea is that <strong>given the experience and the received reward, the agent will update its value function or policy.</strong>",ca,W,de="Monte Carlo and Temporal Difference Learning are two different <strong>strategies on how to train our value function or our policy function.</strong> Both of them <strong>use experience to solve the RL problem.</strong>",oa,T,en,ks,ye="an entire episode of experience before learning.",ln,q,pn,ha,ll='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo separator="true">,</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_t, A_t, R_{t+1}, S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',ga,ua,A,fe="We’ll explain both of them <strong>using a value-based method example.</strong>",va,U,da,S,mn,ya,pl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',fa,B,rn,wa,ml='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ba,xa,F,we="So it requires a <strong>complete episode of interaction before updating our value function.</strong>",_a,Q,be,Ma,J,xe="If we take an example:",za,K,_e,ka,d,Ls,Me="<p>We always start the episode <strong>at the same starting point.</strong></p>",cn,Ts,ze="<p><strong>The agent takes actions using the policy</strong>. For instance, using an Epsilon Greedy Strategy, a policy that alternates between exploration (random actions) and exploitation.</p>",on,Ss,ke="<p>We get <strong>the reward and the next state.</strong></p>",hn,Cs,Le="<p>We terminate the episode if the cat eats the mouse or if the mouse moves &gt; 10 steps.</p>",gn,Gs,Te=`<p>At the end of the episode, <strong>we have a list of State, Actions, Rewards, and Next States tuples</strong>
For instance [[State tile 3 bottom, Go Left, +1, State tile 2 bottom], [State tile 2 bottom, Go Left, +0, State tile 1 bottom]…]</p>`,un,Ys,Vs,Rs,vn,La,il='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',dn,yn,X,Hs,fn,Y,wn,Ta,rl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(s_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Sa,bn,Es,Se,xn,Is,Ce="<p>Then <strong>start a new game with this new knowledge</strong></p>",Ca,Z,Ge="By running more and more episodes, <strong>the agent will learn to play better and better.</strong>",Ga,ss,Ve,Va,as,Re="For instance, if we train a state-value function using Monte Carlo:",Ra,ts,He='<li><p>We initialize our value function <strong>so that it returns 0 value for each state</strong></p></li> <li><p>Our learning rate (lr) is 0.1 and our discount rate is 1 (= no discount)</p></li> <li><p>Our mouse <strong>explores the environment and takes random actions</strong></p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4.jpg" alt="Monte Carlo"/></li>',Ha,ns,Ee='<li><p>The mouse made more than 10 steps, so the episode ends .</p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4p.jpg" alt="Monte Carlo"/></li>',Ea,H,Zs,f,_n,Ps,Mn,Ia,cl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>G</mi><mrow><mi>t</mi><mo>=</mo><mn>0</mn></mrow></mrow><annotation encoding="application/x-tex">G{t=0}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6833em;"></span><span class="mord mathnormal">G</span><span class="mord"><span class="mord mathnormal">t</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mord">0</span></span></span></span></span>',zn,Pa,ol='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub><mo>=</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>2</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>3</mn></mrow></msub><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi></mrow><annotation encoding="application/x-tex">G_t = R_{t+1} + R_{t+2} + R_{t+3} ...</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mord">...</span></span></span></span>',Da,$a,hl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><msub><mi>R</mi><mn>2</mn></msub><mo>+</mo><msub><mi>R</mi><mn>3</mn></msub><mo>…</mo></mrow><annotation encoding="application/x-tex">G_0 = R_{1} + R_{2} + R_{3}…</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.1667em;"></span><span class="minner">…</span></span></span></span>',ja,Na,gl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn></mrow><annotation encoding="application/x-tex">G_0 = 1 + 0 + 0 + 0 + 0 + 0 + 1 + 1 + 0 + 0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0</span></span></span></span>',Oa,Wa,ul='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>3</mn></mrow><annotation encoding="application/x-tex">G_0 = 3</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">3</span></span></span></span>',kn,w,E,Ln,Ds,Ie="new",qa,vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Aa,Tn,$s,Pe,Sn,Ua,dl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>G</mi><mn>0</mn></msub><mtext>—</mtext><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [G_0 — V(S_0)]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">—</span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',Ba,Fa,yl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>3</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [3 – 0]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">3–0</span><span class="mclose">]</span></span></span></span>',Qa,Ja,fl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.3</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.3</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.3</span></span></span></span>',Ka,es,De,Xa,ls,Ya,b,js,Cn,Za,wl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Gn,st,bl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',at,tt,xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',nt,et,_l='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\gamma * V(S_{t+1})</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',lt,pt,ps,Vn,ms,Rn,mt,Ml='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',it,rt,C,Hn,ct,zl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ot,G,En,ht,kl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',gt,ut,Ll='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',vt,dt,is,In,V,Pn,yt,Tl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_{t+1})</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ft,wt,Sl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',bt,xt,rs,$e,_t,cs,je="This method is called TD(0) or <strong>one-step TD (update the value function after any individual step).</strong>",Mt,os,Ne,zt,hs,Oe="If we take the same example,",kt,gs,We,Lt,_,Ns,qe="<p>We initialize our value function so that it returns 0 value for each state.</p>",Dn,Os,Ae="<p>Our learning rate (lr) is 0.1, and our discount rate is 1 (no discount).</p>",$n,Ws,Ue="<p>Our mouse begins to explore the environment and takes a random action: <strong>going to the left</strong></p>",jn,us,I,Nn,Tt,Cl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',St,qs,Be="it eats a piece of cheese",On,As,Fe,Ct,vs,Qe,Gt,P,Wn,Vt,Gl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Rt,Ht,ds,qn,Et,Vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>1</mn></msub><mo stretchy="false">)</mo><mo>−</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [R_1 + \\gamma * V(S_1) - V(S_0)]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',It,ys,An,Pt,Rl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>∗</mo><mn>0</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [1 + 1 * 0–0]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">0–0</span><span class="mclose">]</span></span></span></span>',Dt,fs,Un,$t,Hl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.1</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span></span></span></span>',jt,ws,Je="So we just updated our value function for State 0.",Nt,bs,Ke="Now we <strong>continue to interact with this environment with our updated value function.</strong>",Ot,xs,Xe,Wt,_s,Ye="To summarize:",qt,D,Us,Ze="<p>With <em>Monte Carlo</em>, we update the value function from a complete episode, and so we <strong>use the actual accurate discounted return of this episode.</strong></p>",Bn,Ms,z,Fn,Bs,sl="TD Learning",Qn,At,El='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ut,Fs,al="an estimated return called the TD target.",Jn,Qs,tl,Bt,sa,Ft;return j=new he({props:{title:"Monte Carlo vs Temporal Difference Learning",local:"mc-vs-td",headingTag:"h1"}}),U=new he({props:{title:"Monte Carlo: learning at the end of the episode",local:"monte-carlo",headingTag:"h2"}}),ls=new he({props:{title:"Temporal Difference Learning: learning at each step",local:"td-learning",headingTag:"h2"}}),{c(){L=l("meta"),pa=m(),Xs=l("p"),ma=m(),pe(j.$$.fragment),ia=m(),N=l("p"),N.textContent=ue,ra=m(),O=l("p"),O.innerHTML=ve,ca=m(),W=l("p"),W.innerHTML=de,oa=m(),T=l("p"),en=r("On one hand, Monte Carlo uses "),ks=l("strong"),ks.textContent=ye,ln=r(" On the other hand, Temporal Difference uses "),q=l("strong"),pn=r("only a step ("),ha=new h(!1),ga=r(" ) to learn."),ua=m(),A=l("p"),A.innerHTML=fe,va=m(),pe(U.$$.fragment),da=m(),S=l("p"),mn=r("Monte Carlo waits until the end of the episode, calculates "),ya=new h(!1),fa=r(" (return) and uses it as "),B=l("strong"),rn=r("a target for updating "),wa=new h(!1),ba=r("."),xa=m(),F=l("p"),F.innerHTML=we,_a=m(),Q=l("img"),Ma=m(),J=l("p"),J.textContent=xe,za=m(),K=l("img"),ka=m(),d=l("ul"),Ls=l("li"),Ls.innerHTML=Me,cn=m(),Ts=l("li"),Ts.innerHTML=ze,on=m(),Ss=l("li"),Ss.innerHTML=ke,hn=m(),Cs=l("li"),Cs.innerHTML=Le,gn=m(),Gs=l("li"),Gs.innerHTML=Te,un=m(),Ys=l("li"),Vs=l("p"),Rs=l("strong"),vn=r("The agent will sum the total rewards"),La=new h(!1),dn=r(" (to see how well it did)."),yn=m(),X=l("li"),Hs=l("p"),fn=r("It will then "),Y=l("strong"),wn=r("update"),Ta=new h(!1),Sa=r(" based on the formula"),bn=m(),Es=l("img"),xn=m(),Is=l("li"),Is.innerHTML=Ce,Ca=m(),Z=l("p"),Z.innerHTML=Ge,Ga=m(),ss=l("img"),Va=m(),as=l("p"),as.textContent=Re,Ra=m(),ts=l("ul"),ts.innerHTML=He,Ha=m(),ns=l("ul"),ns.innerHTML=Ee,Ea=m(),H=l("ul"),Zs=l("li"),f=l("p"),_n=r("We have a list of state, action, rewards, next_state, "),Ps=l("strong"),Mn=r("we need to calculate the return"),Ia=new h(!1),zn=m(),Pa=new h(!1),Da=r(` (for simplicity, we don’t discount the rewards)
`),$a=new h(!1),ja=m(),Na=new h(!1),Oa=m(),Wa=new h(!1),kn=m(),w=l("li"),E=l("p"),Ln=r("We can now compute the "),Ds=l("strong"),Ds.textContent=Ie,qa=new h(!1),Aa=r(":"),Tn=m(),$s=l("img"),Sn=m(),Ua=new h(!1),Ba=m(),Fa=new h(!1),Qa=m(),Ja=new h(!1),Ka=m(),es=l("img"),Xa=m(),pe(ls.$$.fragment),Ya=m(),b=l("p"),js=l("strong"),Cn=r("Temporal Difference, on the other hand, waits for only one interaction (one step)"),Za=new h(!1),Gn=r(" to form a TD target and update"),st=new h(!1),at=r(" using"),tt=new h(!1),nt=r(" and"),et=new h(!1),lt=r("."),pt=m(),ps=l("p"),Vn=r("The idea with "),ms=l("strong"),Rn=r("TD is to update the"),mt=new h(!1),it=r(" at each step."),rt=m(),C=l("p"),Hn=r("But because we didn’t experience an entire episode, we don’t have"),ct=new h(!1),ot=r(" (expected return). Instead, "),G=l("strong"),En=r("we estimate"),ht=new h(!1),gt=r(" by adding"),ut=new h(!1),vt=r(" and the discounted value of the next state."),dt=m(),is=l("p"),In=r("This is called bootstrapping. It’s called this "),V=l("strong"),Pn=r("because TD bases its update in part on an existing estimate"),yt=new h(!1),ft=r(" and not a complete sample"),wt=new h(!1),bt=r("."),xt=m(),rs=l("img"),_t=m(),cs=l("p"),cs.innerHTML=je,Mt=m(),os=l("img"),zt=m(),hs=l("p"),hs.textContent=Oe,kt=m(),gs=l("img"),Lt=m(),_=l("ul"),Ns=l("li"),Ns.innerHTML=qe,Dn=m(),Os=l("li"),Os.innerHTML=Ae,$n=m(),Ws=l("li"),Ws.innerHTML=Ue,jn=m(),us=l("li"),I=l("p"),Nn=r("It gets a reward "),Tt=new h(!1),St=r(" since "),qs=l("strong"),qs.textContent=Be,On=m(),As=l("img"),Ct=m(),vs=l("img"),Gt=m(),P=l("p"),Wn=r("We can now update "),Vt=new h(!1),Rt=r(":"),Ht=m(),ds=l("p"),qn=r("New "),Et=new h(!1),It=m(),ys=l("p"),An=r("New"),Pt=new h(!1),Dt=m(),fs=l("p"),Un=r("New"),$t=new h(!1),jt=m(),ws=l("p"),ws.textContent=Je,Nt=m(),bs=l("p"),bs.innerHTML=Ke,Ot=m(),xs=l("img"),Wt=m(),_s=l("p"),_s.textContent=Ye,qt=m(),D=l("ul"),Us=l("li"),Us.innerHTML=Ze,Bn=m(),Ms=l("li"),z=l("p"),Fn=r("With "),Bs=l("em"),Bs.textContent=sl,Qn=r(", we update the value function from a step, and we replace"),At=new h(!1),Ut=r(", which we don’t know, with "),Fs=l("strong"),Fs.textContent=al,Jn=m(),Qs=l("img"),Bt=m(),sa=l("p"),this.h()},l(s){const n=Nl("svelte-u9bgzb",document.head);L=p(n,"META",{name:!0,content:!0}),n.forEach(a),pa=i(s),Xs=p(s,"P",{}),o(Xs).forEach(a),ma=i(s),me(j.$$.fragment,s),ia=i(s),N=p(s,"P",{"data-svelte-h":!0}),g(N)!=="svelte-1akl2qa"&&(N.textContent=ue),ra=i(s),O=p(s,"P",{"data-svelte-h":!0}),g(O)!=="svelte-66f1fn"&&(O.innerHTML=ve),ca=i(s),W=p(s,"P",{"data-svelte-h":!0}),g(W)!=="svelte-c9mnn7"&&(W.innerHTML=de),oa=i(s),T=p(s,"P",{});var aa=o(T);en=c(aa,"On one hand, Monte Carlo uses "),ks=p(aa,"STRONG",{"data-svelte-h":!0}),g(ks)!=="svelte-qfkr11"&&(ks.textContent=ye),ln=c(aa," On the other hand, Temporal Difference uses "),q=p(aa,"STRONG",{});var Qt=o(q);pn=c(Qt,"only a step ("),ha=u(Qt,!1),ga=c(Qt," ) to learn."),Qt.forEach(a),aa.forEach(a),ua=i(s),A=p(s,"P",{"data-svelte-h":!0}),g(A)!=="svelte-15q9y0k"&&(A.innerHTML=fe),va=i(s),me(U.$$.fragment,s),da=i(s),S=p(s,"P",{});var ta=o(S);mn=c(ta,"Monte Carlo waits until the end of the episode, calculates "),ya=u(ta,!1),fa=c(ta," (return) and uses it as "),B=p(ta,"STRONG",{});var Jt=o(B);rn=c(Jt,"a target for updating "),wa=u(Jt,!1),ba=c(Jt,"."),Jt.forEach(a),ta.forEach(a),xa=i(s),F=p(s,"P",{"data-svelte-h":!0}),g(F)!=="svelte-1qajh7u"&&(F.innerHTML=we),_a=i(s),Q=p(s,"IMG",{src:!0,alt:!0}),Ma=i(s),J=p(s,"P",{"data-svelte-h":!0}),g(J)!=="svelte-w96c5b"&&(J.textContent=xe),za=i(s),K=p(s,"IMG",{src:!0,alt:!0}),ka=i(s),d=p(s,"UL",{});var y=o(d);Ls=p(y,"LI",{"data-svelte-h":!0}),g(Ls)!=="svelte-em32nl"&&(Ls.innerHTML=Me),cn=i(y),Ts=p(y,"LI",{"data-svelte-h":!0}),g(Ts)!=="svelte-1xtd55m"&&(Ts.innerHTML=ze),on=i(y),Ss=p(y,"LI",{"data-svelte-h":!0}),g(Ss)!=="svelte-ragojc"&&(Ss.innerHTML=ke),hn=i(y),Cs=p(y,"LI",{"data-svelte-h":!0}),g(Cs)!=="svelte-bq5445"&&(Cs.innerHTML=Le),gn=i(y),Gs=p(y,"LI",{"data-svelte-h":!0}),g(Gs)!=="svelte-10uvow2"&&(Gs.innerHTML=Te),un=i(y),Ys=p(y,"LI",{});var nl=o(Ys);Vs=p(nl,"P",{});var Kn=o(Vs);Rs=p(Kn,"STRONG",{});var Xn=o(Rs);vn=c(Xn,"The agent will sum the total rewards"),La=u(Xn,!1),Xn.forEach(a),dn=c(Kn," (to see how well it did)."),Kn.forEach(a),nl.forEach(a),yn=i(y),X=p(y,"LI",{});var Kt=o(X);Hs=p(Kt,"P",{});var Yn=o(Hs);fn=c(Yn,"It will then "),Y=p(Yn,"STRONG",{});var Xt=o(Y);wn=c(Xt,"update"),Ta=u(Xt,!1),Sa=c(Xt," based on the formula"),Xt.forEach(a),Yn.forEach(a),bn=i(Kt),Es=p(Kt,"IMG",{src:!0,alt:!0}),Kt.forEach(a),xn=i(y),Is=p(y,"LI",{"data-svelte-h":!0}),g(Is)!=="svelte-1a0nyac"&&(Is.innerHTML=Ce),y.forEach(a),Ca=i(s),Z=p(s,"P",{"data-svelte-h":!0}),g(Z)!=="svelte-12n0xeg"&&(Z.innerHTML=Ge),Ga=i(s),ss=p(s,"IMG",{src:!0,alt:!0}),Va=i(s),as=p(s,"P",{"data-svelte-h":!0}),g(as)!=="svelte-1xxhd0z"&&(as.textContent=Re),Ra=i(s),ts=p(s,"UL",{"data-svelte-h":!0}),g(ts)!=="svelte-fine1n"&&(ts.innerHTML=He),Ha=i(s),ns=p(s,"UL",{"data-svelte-h":!0}),g(ns)!=="svelte-h65p8t"&&(ns.innerHTML=Ee),Ea=i(s),H=p(s,"UL",{});var Yt=o(H);Zs=p(Yt,"LI",{});var el=o(Zs);f=p(el,"P",{});var M=o(f);_n=c(M,"We have a list of state, action, rewards, next_state, "),Ps=p(M,"STRONG",{});var Zn=o(Ps);Mn=c(Zn,"we need to calculate the return"),Ia=u(Zn,!1),Zn.forEach(a),zn=i(M),Pa=u(M,!1),Da=c(M,` (for simplicity, we don’t discount the rewards)
`),$a=u(M,!1),ja=i(M),Na=u(M,!1),Oa=i(M),Wa=u(M,!1),M.forEach(a),el.forEach(a),kn=i(Yt),w=p(Yt,"LI",{});var k=o(w);E=p(k,"P",{});var na=o(E);Ln=c(na,"We can now compute the "),Ds=p(na,"STRONG",{"data-svelte-h":!0}),g(Ds)!=="svelte-xvdw54"&&(Ds.textContent=Ie),qa=u(na,!1),Aa=c(na,":"),na.forEach(a),Tn=i(k),$s=p(k,"IMG",{src:!0,alt:!0}),Sn=i(k),Ua=u(k,!1),Ba=i(k),Fa=u(k,!1),Qa=i(k),Ja=u(k,!1),k.forEach(a),Yt.forEach(a),Ka=i(s),es=p(s,"IMG",{src:!0,alt:!0}),Xa=i(s),me(ls.$$.fragment,s),Ya=i(s),b=p(s,"P",{});var R=o(b);js=p(R,"STRONG",{});var se=o(js);Cn=c(se,"Temporal Difference, on the other hand, waits for only one interaction (one step)"),Za=u(se,!1),se.forEach(a),Gn=c(R," to form a TD target and update"),st=u(R,!1),at=c(R," using"),tt=u(R,!1),nt=c(R," and"),et=u(R,!1),lt=c(R,"."),R.forEach(a),pt=i(s),ps=p(s,"P",{});var ae=o(ps);Vn=c(ae,"The idea with "),ms=p(ae,"STRONG",{});var Zt=o(ms);Rn=c(Zt,"TD is to update the"),mt=u(Zt,!1),it=c(Zt," at each step."),Zt.forEach(a),ae.forEach(a),rt=i(s),C=p(s,"P",{});var ea=o(C);Hn=c(ea,"But because we didn’t experience an entire episode, we don’t have"),ct=u(ea,!1),ot=c(ea," (expected return). Instead, "),G=p(ea,"STRONG",{});var Js=o(G);En=c(Js,"we estimate"),ht=u(Js,!1),gt=c(Js," by adding"),ut=u(Js,!1),vt=c(Js," and the discounted value of the next state."),Js.forEach(a),ea.forEach(a),dt=i(s),is=p(s,"P",{});var te=o(is);In=c(te,"This is called bootstrapping. It’s called this "),V=p(te,"STRONG",{});var Ks=o(V);Pn=c(Ks,"because TD bases its update in part on an existing estimate"),yt=u(Ks,!1),ft=c(Ks," and not a complete sample"),wt=u(Ks,!1),bt=c(Ks,"."),Ks.forEach(a),te.forEach(a),xt=i(s),rs=p(s,"IMG",{src:!0,alt:!0}),_t=i(s),cs=p(s,"P",{"data-svelte-h":!0}),g(cs)!=="svelte-1a7834f"&&(cs.innerHTML=je),Mt=i(s),os=p(s,"IMG",{src:!0,alt:!0}),zt=i(s),hs=p(s,"P",{"data-svelte-h":!0}),g(hs)!=="svelte-1ijk2ql"&&(hs.textContent=Oe),kt=i(s),gs=p(s,"IMG",{src:!0,alt:!0}),Lt=i(s),_=p(s,"UL",{});var $=o(_);Ns=p($,"LI",{"data-svelte-h":!0}),g(Ns)!=="svelte-1uhtcgd"&&(Ns.innerHTML=qe),Dn=i($),Os=p($,"LI",{"data-svelte-h":!0}),g(Os)!=="svelte-1hykgj"&&(Os.innerHTML=Ae),$n=i($),Ws=p($,"LI",{"data-svelte-h":!0}),g(Ws)!=="svelte-toxj8r"&&(Ws.innerHTML=Ue),jn=i($),us=p($,"LI",{});var sn=o(us);I=p(sn,"P",{});var la=o(I);Nn=c(la,"It gets a reward "),Tt=u(la,!1),St=c(la," since "),qs=p(la,"STRONG",{"data-svelte-h":!0}),g(qs)!=="svelte-1cpiv0b"&&(qs.textContent=Be),la.forEach(a),On=i(sn),As=p(sn,"IMG",{src:!0,alt:!0}),sn.forEach(a),$.forEach(a),Ct=i(s),vs=p(s,"IMG",{src:!0,alt:!0}),Gt=i(s),P=p(s,"P",{});var an=o(P);Wn=c(an,"We can now update "),Vt=u(an,!1),Rt=c(an,":"),an.forEach(a),Ht=i(s),ds=p(s,"P",{});var ne=o(ds);qn=c(ne,"New "),Et=u(ne,!1),ne.forEach(a),It=i(s),ys=p(s,"P",{});var ee=o(ys);An=c(ee,"New"),Pt=u(ee,!1),ee.forEach(a),Dt=i(s),fs=p(s,"P",{});var le=o(fs);Un=c(le,"New"),$t=u(le,!1),le.forEach(a),jt=i(s),ws=p(s,"P",{"data-svelte-h":!0}),g(ws)!=="svelte-9mnez4"&&(ws.textContent=Je),Nt=i(s),bs=p(s,"P",{"data-svelte-h":!0}),g(bs)!=="svelte-114rjrk"&&(bs.innerHTML=Ke),Ot=i(s),xs=p(s,"IMG",{src:!0,alt:!0}),Wt=i(s),_s=p(s,"P",{"data-svelte-h":!0}),g(_s)!=="svelte-gcetae"&&(_s.textContent=Ye),qt=i(s),D=p(s,"UL",{});var tn=o(D);Us=p(tn,"LI",{"data-svelte-h":!0}),g(Us)!=="svelte-17v3eqc"&&(Us.innerHTML=Ze),Bn=i(tn),Ms=p(tn,"LI",{});var nn=o(Ms);z=p(nn,"P",{});var zs=o(z);Fn=c(zs,"With "),Bs=p(zs,"EM",{"data-svelte-h":!0}),g(Bs)!=="svelte-1kiwr2w"&&(Bs.textContent=sl),Qn=c(zs,", we update the value function from a step, and we replace"),At=u(zs,!1),Ut=c(zs,", which we don’t know, with "),Fs=p(zs,"STRONG",{"data-svelte-h":!0}),g(Fs)!=="svelte-vbrp5s"&&(Fs.textContent=al),zs.forEach(a),Jn=i(nn),Qs=p(nn,"IMG",{src:!0,alt:!0}),nn.forEach(a),tn.forEach(a),Bt=i(s),sa=p(s,"P",{}),o(sa).forEach(a),this.h()},h(){v(L,"name","hf:doc:metadata"),v(L,"content",Wl),ha.a=ga,ya.a=fa,wa.a=ba,x(Q.src,be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/monte-carlo-approach.jpg")||v(Q,"src",be),v(Q,"alt","Monte Carlo"),x(K.src,_e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-2.jpg")||v(K,"src",_e),v(K,"alt","Monte Carlo"),La.a=null,Ta.a=Sa,x(Es.src,Se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3.jpg")||v(Es,"src",Se),v(Es,"alt","Monte Carlo"),x(ss.src,Ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3p.jpg")||v(ss,"src",Ve),v(ss,"alt","Monte Carlo"),Ia.a=null,Pa.a=Da,$a.a=ja,Na.a=Oa,Wa.a=null,qa.a=Aa,x($s.src,Pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5.jpg")||v($s,"src",Pe),v($s,"alt","Monte Carlo"),Ua.a=Ba,Fa.a=Qa,Ja.a=null,x(es.src,De="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5p.jpg")||v(es,"src",De),v(es,"alt","Monte Carlo"),Za.a=null,st.a=at,tt.a=nt,et.a=lt,mt.a=it,ct.a=ot,ht.a=gt,ut.a=vt,yt.a=ft,wt.a=bt,x(rs.src,$e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1.jpg")||v(rs,"src",$e),v(rs,"alt","Temporal Difference"),x(os.src,Ne="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1p.jpg")||v(os,"src",Ne),v(os,"alt","Temporal Difference"),x(gs.src,We="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2.jpg")||v(gs,"src",We),v(gs,"alt","Temporal Difference"),Tt.a=St,x(As.src,Fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2p.jpg")||v(As,"src",Fe),v(As,"alt","Temporal Difference"),x(vs.src,Qe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3.jpg")||v(vs,"src",Qe),v(vs,"alt","Temporal Difference"),Vt.a=Rt,Et.a=null,Pt.a=null,$t.a=null,x(xs.src,Xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3p.jpg")||v(xs,"src",Xe),v(xs,"alt","Temporal Difference"),At.a=Ut,x(Qs.src,tl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Summary.jpg")||v(Qs,"src",tl),v(Qs,"alt","Summary")},m(s,n){t(document.head,L),e(s,pa,n),e(s,Xs,n),e(s,ma,n),ie(j,s,n),e(s,ia,n),e(s,N,n),e(s,ra,n),e(s,O,n),e(s,ca,n),e(s,W,n),e(s,oa,n),e(s,T,n),t(T,en),t(T,ks),t(T,ln),t(T,q),t(q,pn),ha.m(ll,q),t(q,ga),e(s,ua,n),e(s,A,n),e(s,va,n),ie(U,s,n),e(s,da,n),e(s,S,n),t(S,mn),ya.m(pl,S),t(S,fa),t(S,B),t(B,rn),wa.m(ml,B),t(B,ba),e(s,xa,n),e(s,F,n),e(s,_a,n),e(s,Q,n),e(s,Ma,n),e(s,J,n),e(s,za,n),e(s,K,n),e(s,ka,n),e(s,d,n),t(d,Ls),t(d,cn),t(d,Ts),t(d,on),t(d,Ss),t(d,hn),t(d,Cs),t(d,gn),t(d,Gs),t(d,un),t(d,Ys),t(Ys,Vs),t(Vs,Rs),t(Rs,vn),La.m(il,Rs),t(Vs,dn),t(d,yn),t(d,X),t(X,Hs),t(Hs,fn),t(Hs,Y),t(Y,wn),Ta.m(rl,Y),t(Y,Sa),t(X,bn),t(X,Es),t(d,xn),t(d,Is),e(s,Ca,n),e(s,Z,n),e(s,Ga,n),e(s,ss,n),e(s,Va,n),e(s,as,n),e(s,Ra,n),e(s,ts,n),e(s,Ha,n),e(s,ns,n),e(s,Ea,n),e(s,H,n),t(H,Zs),t(Zs,f),t(f,_n),t(f,Ps),t(Ps,Mn),Ia.m(cl,Ps),t(f,zn),Pa.m(ol,f),t(f,Da),$a.m(hl,f),t(f,ja),Na.m(gl,f),t(f,Oa),Wa.m(ul,f),t(H,kn),t(H,w),t(w,E),t(E,Ln),t(E,Ds),qa.m(vl,E),t(E,Aa),t(w,Tn),t(w,$s),t(w,Sn),Ua.m(dl,w),t(w,Ba),Fa.m(yl,w),t(w,Qa),Ja.m(fl,w),e(s,Ka,n),e(s,es,n),e(s,Xa,n),ie(ls,s,n),e(s,Ya,n),e(s,b,n),t(b,js),t(js,Cn),Za.m(wl,js),t(b,Gn),st.m(bl,b),t(b,at),tt.m(xl,b),t(b,nt),et.m(_l,b),t(b,lt),e(s,pt,n),e(s,ps,n),t(ps,Vn),t(ps,ms),t(ms,Rn),mt.m(Ml,ms),t(ms,it),e(s,rt,n),e(s,C,n),t(C,Hn),ct.m(zl,C),t(C,ot),t(C,G),t(G,En),ht.m(kl,G),t(G,gt),ut.m(Ll,G),t(G,vt),e(s,dt,n),e(s,is,n),t(is,In),t(is,V),t(V,Pn),yt.m(Tl,V),t(V,ft),wt.m(Sl,V),t(V,bt),e(s,xt,n),e(s,rs,n),e(s,_t,n),e(s,cs,n),e(s,Mt,n),e(s,os,n),e(s,zt,n),e(s,hs,n),e(s,kt,n),e(s,gs,n),e(s,Lt,n),e(s,_,n),t(_,Ns),t(_,Dn),t(_,Os),t(_,$n),t(_,Ws),t(_,jn),t(_,us),t(us,I),t(I,Nn),Tt.m(Cl,I),t(I,St),t(I,qs),t(us,On),t(us,As),e(s,Ct,n),e(s,vs,n),e(s,Gt,n),e(s,P,n),t(P,Wn),Vt.m(Gl,P),t(P,Rt),e(s,Ht,n),e(s,ds,n),t(ds,qn),Et.m(Vl,ds),e(s,It,n),e(s,ys,n),t(ys,An),Pt.m(Rl,ys),e(s,Dt,n),e(s,fs,n),t(fs,Un),$t.m(Hl,fs),e(s,jt,n),e(s,ws,n),e(s,Nt,n),e(s,bs,n),e(s,Ot,n),e(s,xs,n),e(s,Wt,n),e(s,_s,n),e(s,qt,n),e(s,D,n),t(D,Us),t(D,Bn),t(D,Ms),t(Ms,z),t(z,Fn),t(z,Bs),t(z,Qn),At.m(El,z),t(z,Ut),t(z,Fs),t(Ms,Jn),t(Ms,Qs),e(s,Bt,n),e(s,sa,n),Ft=!0},p:Pl,i(s){Ft||(re(j.$$.fragment,s),re(U.$$.fragment,s),re(ls.$$.fragment,s),Ft=!0)},o(s){ce(j.$$.fragment,s),ce(U.$$.fragment,s),ce(ls.$$.fragment,s),Ft=!1},d(s){s&&(a(pa),a(Xs),a(ma),a(ia),a(N),a(ra),a(O),a(ca),a(W),a(oa),a(T),a(ua),a(A),a(va),a(da),a(S),a(xa),a(F),a(_a),a(Q),a(Ma),a(J),a(za),a(K),a(ka),a(d),a(Ca),a(Z),a(Ga),a(ss),a(Va),a(as),a(Ra),a(ts),a(Ha),a(ns),a(Ea),a(H),a(Ka),a(es),a(Xa),a(Ya),a(b),a(pt),a(ps),a(rt),a(C),a(dt),a(is),a(xt),a(rs),a(_t),a(cs),a(Mt),a(os),a(zt),a(hs),a(kt),a(gs),a(Lt),a(_),a(Ct),a(vs),a(Gt),a(P),a(Ht),a(ds),a(It),a(ys),a(Dt),a(fs),a(jt),a(ws),a(Nt),a(bs),a(Ot),a(xs),a(Wt),a(_s),a(qt),a(D),a(Bt),a(sa)),a(L),oe(j,s),oe(U,s),oe(ls,s)}}}const Wl='{"title":"Monte Carlo vs Temporal Difference Learning","local":"mc-vs-td","sections":[{"title":"Monte Carlo: learning at the end of the episode","local":"monte-carlo","sections":[],"depth":2},{"title":"Temporal Difference Learning: learning at each step","local":"td-learning","sections":[],"depth":2}],"depth":1}';function ql(ge){return Dl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fl extends $l{constructor(L){super(),jl(this,L,ql,Ol,Il,{})}}export{Fl as component};
